unit Unit1;

{$mode objfpc}{$H+}

interface

uses
 Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Menus,typinfo,
 T_Newprop;

type

 tmemo=class(stdctrls.tmemo)
  published
   property text;
 end;

 { TForm1 }

 TForm1 = class(TForm)
  Button1: TButton;
  Button2: TButton;
  Button3: TButton;
  Button4: TButton;
  CheckBox1: TCheckBox;
  ComboBox1: TComboBox;
  Label1: TLabel;
  MainMenu1: TMainMenu;
  Memo1: TMemo;
  MenuItem1: TMenuItem;
  MenuItem2: TMenuItem;
  procedure Button1Click(Sender: TObject);
  procedure Button2Click(Sender: TObject);
  procedure Button3Click(Sender: TObject);
  procedure Button4Click(Sender: TObject);
  procedure MenuItem2Click(Sender: TObject);
 private

 public

 end;

var
 Form1: TForm1;
 T1,T2:integer;

implementation

{$R *.lfm}

{ TForm1 }

// Beispiel neue Properties von button1 setzten
procedure TForm1.Button1Click(Sender: TObject);
var  an_aus_test:boolean;
begin
 T1:=T1+10;
 T2:=T2-11;
 set_prop(button1,'tag1',T1); // <-- Integer
 set_prop(button1,'tag2',T2); // <-- Integer
 set_prop(button1,'htmllink','button1.html'); // <-- String

 an_aus_test:=not get_prop(button1,'an_aus'); // Booleanwert lesen und invertieren
 set_prop(button1,'an_aus',an_aus_test); // <-- Boolean

 set_prop(button1,'kommazahl',1.2345678); // <-- Double / Float
end;

// Beispiel Properties von button1 auslesen
procedure TForm1.Button2Click(Sender: TObject);
var s:string;
    a:integer;
    b:integer;
    c:boolean;
    d:double;
begin
 memo1.clear;
 a:=get_prop(button1,'tag1');  // <--- Integerwert
 memo1.lines.add(inttostr(a));
 b:=get_prop(button1,'tag2');  // <--- Integerwert
 memo1.lines.add(inttostr(b));
 s:=get_prop(button1,'htmllink'); // <--- String
 memo1.lines.add(s);
 c:=get_prop(button1,'an_aus');   // <--- Boolean
 memo1.lines.add(booltostr(c,true));
 d:=get_prop(button1,'kommazahl'); // <--- Double / Float
 memo1.lines.add(floattostr(d));
end;

// MenuItems per Text setzen
procedure TForm1.Button3Click(Sender: TObject);
begin
 set_prop_from_string('form1.menuitem1.caption=Datei');
 set_prop_from_string('form1.menuitem2.caption=Programmende');
end;

// Beispiel set_prop_from_string
procedure TForm1.Button4Click(Sender: TObject);
begin
 set_prop_from_string(combobox1.text);
end;

// Programmende
procedure TForm1.MenuItem2Click(Sender: TObject);
begin
 close;
end;




end.

